#!/usr/bin/python
# -*- coding: utf8 -*-
""" Show basic string operations """
import sys

print "Size of string:", sys.getsizeof("0123456789")
print
print "Constants:", "string's", "\"quoted\"", '"', """
multi line
strings. Even with " and ' tokens.
""",
print "This line \
contains no new lines.",
print r"Raw strings ignore the '\' token"  # handy for regular expressions
print "Operators:", "one" + "two", "A" * 5, chr(64), ord('F'), ord(u'€')

print "Functions:", len("abcdefg"), "abc".capitalize(), "abcdëf".upper(),
print u"abcdëf".upper(), "ACdE".lower(), "AbbA".swapcase()

print "Search:", "aabaabaab".count("ab", 1, 12), "abba".find("bb"),
print "abccd".endswith("ccd"), "abcd".startswith("abc"),
print "aabab".replace("ab", "cd"), "abcdefabc".rfind("ab"),

try:
    print "abbba".index("aba")
except ValueError:
    print False
print "Tests:",  "abccd".endswith("ccd"), "AbcD".isalpha(), "abbA".islower(),
print " \t".isspace()
print "Join:", ", ".join(["a", "bc", "d", "e"])

print "Split:", "ab,cd,ef".rpartition(","), "a,b,c,d,e".rsplit(",", 2)
print "Strip:", "abcafab".rstrip("fab"), "abcdefa".strip("af"), " 23 ".strip()
