""" Show basic function usage """


def compare(a, b):
    """ Compare two value with text output """
    print a, "is",
    if a > b:
        print "higher",
    elif a == b:
        print "equals",
    else:
        print "lower",
    print "than", b

compare(1, 2)
compare(3, 3)
compare("4", "13")

print "Tail recursion:"


def fn1(n, l):
    """ Multiply n with l and continue for l-1 """
    if l == 0:
        return n
    print l, ':', n
    return fn1(n * l, l - 1)

print fn1(5, 6)

print "More efficient rewrite:"


def fn2(n, l):
    """ Multiply n with l and continue for l-1 """
    while True:
        if l == 0:
            return n
        print l, ':', n
        n, l = n * l, l - 1

print fn2(5, 6)

print "Global variables:",
var = 2


def print_var():
    """ Show the value of a global variable """
    print var,
print_var()


# mutate1 is not sensible in python     pylint: disable-msg=W0621


def mutate1():
    """ Try to change the global variable """
    var = 4
    print var,
mutate1()
print var,


def mutate2():
    """ Really change the global variable """
    global var
    var = 4
mutate2()
print var
