""" Show the usage of the with statement """


class Routine:
    """ The __exit__ clause will normally allways run """
    def __init__(self, name):
        self.name = name

    def __enter__(self):
        print "starting", self.name

    def __exit__(self, err, value, traceback):
        print "finished", self.name
        if not err is None:
            print "exception", err, "value", value
        return True


with Routine("Test") as r:
    print 2 / 0
    print "not reachable"
print "stoppped"
