""" How do regular expression work in python """
import re

f = re.search("hell", "hello my dear")
if f:
    print "Found: on", f.start(), "till", f.end()
print re.match("dear", "hello my dear")
reg = re.compile(r"(.*)dear$")
m = reg.match("hello my dear")
if m:
    print "Found: 'dear' at the end of '" + m.group(1) + "'"
    print "All groups:", m.groups()

print "Splitting:",
for s in re.split("[.,]+ *", "this,, is,  something..to.parse"):
    print s,
print

print "Replacing:", re.sub("i", "I", "This is something completely different")
