""" Show generators in action """


class data:
    """ Show how to create an iterator """
    def __init__(self):
        self.i = 0

    def __iter__(self):
        self.i = 0
        return self

    def next(self):
        """ Return next element """
        if self.i < 10:
            self.i += 1
            return self.i
        raise StopIteration

print "iterator:",
for x in data():
    print x,
print


def reverse(ls):
    """ Efficient reverse of some container """
    for index in range(len(ls) - 1, -1, -1):
        yield data[index]

print "reversed:",
for x in reverse(("a", "c", "e", "g")):
    print x,
print


l = ["a", "b", "c"]
print "generator:", ["{" + x + "}" for x in l]
print "filter:", filter(lambda x: x != 'b', l)
