""" Show usage of the dict type """

a = {1: 'this', 2: 'is'}
a[3] = "no"
a[4] = "list"
b = dict(another=3, value=4)
c = dict([(3, 'different'), (4, 'value')])
d = dict.fromkeys(xrange(1, 5), "a")
print "Constants:", a, "length", len(a), b, c, d

print "Keys:",
for v in a:  # a.iter() or a.iterkeys() or a.keys()
    print str(v) + ':' + a[v],
print

print "Values:",
for v in a.itervalues():  # a.values() is possible but less efficient
    print v,
print

a[3] = "a"
print "Items:",
for k, v in a.iteritems():  # a.items()
    print str(k) + ':' + v,
print

del a[1]
print "Removed:", a, a.get(1, "something")

print "Tests:", 'another' in b, 1 not in a
print "Dict mutation:", a.pop(3), a.popitem(), a.setdefault(4, ""), a
a.clear()

b.update(added=5, too=6)
b.update([('another', 2)])
print "Update:", b, sorted(b)
