""" Show list operations """

import sys

print "Size of a list:", sys.getsizeof([]), sys.getsizeof([1, 2, 3, 4, 5]),
print sys.getsizeof([1, 2, 3, 4, 'this is much bigger'])
print
print "Constants:", [1, 2, 3, 'a']

l = [1, 2, 2, 3]
print "Operators:", l + ['a', 'b'], l * 2, l[1]
print "Slicing:", l[1:3], l[2:], l[-1:], l[:-2], [1, 2, 3, 4, 5, 6, 7][::2]
print "Functions:", len(l), max(l), min(l), l.index(2), l.count(2)

del l[2]
print "Removed 3:", l
l += [3, 4, 5]
print "Added some:", l
l.append(6)
print "Added more:", l
l.extend([7, 8, 9])
print "Even more:", l
del l[:2]
print "Removed start:", l
del l[-4:]
print "Removed tail:", l
print "Boolean:", l < [4], l == [3, 3, 4, 5]

print "Loop",
for v in l:
    print v * 2,
print

l[:2] = [1, 2, 3]
print "Overwrite:", l,
l.reverse()
print l

l.reverse()
l.insert(3, 16)
print "Insert:", l
l.sort()
print "Sorted:", l, sorted("Me and my house alone!".split(), key=str.lower)

l.remove(16)
print "Removed:", l

print "Pop:", l.pop(), l, l.pop(0), l
