""" Show set operations """

s = set([1, 2, 5])
t = set([1, 3, 5])
print "Constants:", s, t, "length", len(s)
print "Operators:",
print s | t,  # s.union(t)
print s & t,  # s.intersection(t)
print s - t,  # s.difference(t)
print s ^ t  # s.symmetric_difference(t)
print "Tests:", 2 in s, 5 not in s,
print s.isdisjoint([4, 6, 2]),  # True is there are no elements in common
print s <= (s & frozenset(xrange(4))), s.issubset(xrange(6)),
print s | t > set(xrange(4)) - set(xrange(1))  # (s | t).issuperset(o)

s |= frozenset([6, 7])  # s.update([6,7])
s &= frozenset(xrange(7))  # s.intersection_update(xrange(7))
s ^= frozenset(xrange(9))  # s.symmetric_difference_update(xrange(9))
s -= frozenset([8])  # s.difference_update([8])
print "Change operators:", s

s.add(5)
s.remove(0)
s.discard(0)
print "Set mutations:", s, s.pop(), s
s.clear()
