""" Show function default values """


def fn(a, b, c=1, d=2):
    """ Use default values """
    print a, b, c, d

print "Only default:",
fn(1, 2)
print "Named argument:",
fn(1, 2, d=3)
print "All arguments:",
fn(1, 2, 3, 4)


def mult(*args):
    """ Show multiple arguments """
    print args

print "Multiple arguments:",
mult(1, 2, 3, 4)


def combi(*args, **dict_args):
    """ Show mulitple and named arguments """
    print args, dict_args

print "Combi arguments:",
combi(1, 2, a=3, b=4, c=5)

first = (1, 2, 3, 4)
second = {'a': 5, 'b': 6, 'c': 7}

print "Feed list:",
fn(*first)

print "Feed dict:",
fn(**second)

print "Feed combi:",
combi(*first, **second)
