""" Show different layout options """
x = 1.00051
print "Decimals:", "%0.3f" % x
print "Columns:"
print "%-7s %6s %8s" % ("Name", "Number", "Perc.")
layout = "%-7s %06i %6.2f %%"
print layout % ("This", 129, 12.4)
print layout % ("Another", 10233, 1.4)

size = 12
decimals = 2
print "%*.*f" % (size, decimals, x)


class Person:
    """ Person information class """
    def __init__(self, name, address, zipcode, place, age):
        self.name = name
        self.address = address
        self.zipcode = zipcode
        self.place = place
        self.age = age

p = []
p.append(Person("Eric Buckle", "4th drive 1022", "93822 AR", "New York", 25))
p.append(Person("J. Daniels", "10th aventue 217", "28123 L", "San Diego", 36))

rec = """
<tr><th>%(name)s</th>
    <td>%(address)s</td>
    <td>%(zipcode)s</td>
    <td>%(place)s</td>
    <td align=right>%(age)04d</td>
</tr>
"""

with open("/tmp/output.html", 'w') as f:
    f.write("<table border=2>")
    for person in p:
        f.write(rec % person.__dict__)
    f.write("</table>")

# show result: firefox /tmp/output.html
