""" Show how to handle templates with mako """
from mako.template import Template


class Member:
    """ simple example class """
    def __init__(self, name, saldo):
        self.name = name
        self.saldo = saldo

members = [
    Member("Fred", 12.50),
    Member("Mike", -2.10),
    Member("Dexter", 1.12)
]

template = Template(filename='page.txt', module_directory='/tmp/templates')
with open("out.html", "w") as f:
    f.write(template.render(table=members))

# show with: firefox out.html
